#include "Options.h"
#include "utility.h"

OptionGroup::OptionGroup()
:Glib::OptionGroup("subtitleeditor...", "description...", "help...")
{
	set_translation_domain(GETTEXT_PACKAGE);

	// encoding
	Glib::OptionEntry entryEncoding;
	entryEncoding.set_long_name("encoding");
	entryEncoding.set_short_name('e');
	entryEncoding.set_description("encoding used to open files");
	entryEncoding.set_arg_description(_("ENCODING"));
	add_entry(entryEncoding, encoding);

	// video
	Glib::OptionEntry entryVideo;
	entryVideo.set_long_name("video");
	entryVideo.set_short_name('v');
	entryVideo.set_description("open video file");
	entryVideo.set_arg_description(_("FILE"));
	add_entry(entryVideo, video);
		
	// waveform
	Glib::OptionEntry entryWaveform;
	entryWaveform.set_long_name("waveform");
	entryWaveform.set_short_name('w');
	entryWaveform.set_description("open waveform file");
	entryWaveform.set_arg_description(_("FILE"));
	add_entry(entryWaveform, waveform);

#ifdef ENABLE_UNITTEST
	Glib::OptionEntry entryUnitTest;
	entryUnitTest.set_short_name('u');
	entryUnitTest.set_long_name("unittest");
	entryUnitTest.set_description("Launch a unit test suite");
	add_entry(entryUnitTest, launch_unittest);
#endif

	// FILES...
	Glib::OptionEntry entryFiles;
	entryFiles.set_long_name("");
	entryFiles.set_short_name('\0');
	entryFiles.set_description("");
	entryFiles.set_arg_description(_("[FILE...]"));
	//entryFiles.set_flags(Glib::OptionEntry::FLAG_FILENAME);
	add_entry(entryFiles, files);

#ifdef DEBUG

#define add_debug_option(name, value) { \
					Glib::OptionEntry e; \
					e.set_long_name("debug-"#name); \
					add_entry(e, value); \
				}

	add_debug_option(all, debug_all);
	add_debug_option(app, debug_app);
	add_debug_option(view, debug_view);
	add_debug_option(loader, debug_loader);
	add_debug_option(saver, debug_saver);
	add_debug_option(search, debug_search);
	add_debug_option(regex, debug_regex);
	add_debug_option(video-player, debug_video_player);
	add_debug_option(spell-checking, debug_spell_checking);
	add_debug_option(waveform, debug_waveform);
	add_debug_option(utility, debug_utility);

#endif//DEBUG
}


