#include "DeleteSubtitleSelect.h"


/*
 *
 */
bool DeleteSubtitleSelect::execute(Document &doc)
{
	Glib::RefPtr<Gtk::TreeSelection> selection = doc.get_subtitle_view()->get_selection();

	std::vector<Gtk::TreeModel::Path> rows = selection->get_selected_rows();

	if(rows.size() == 0)
	{
		doc.flash_message(_("Please select at least a subtitle."));
		return false;
	}

	Glib::RefPtr<SubtitleModel> model = doc.get_subtitle_model();

	// select previous subtitle after
	Gtk::TreeIter previous = model->find_previous(model->get_iter(rows[0])); 

	unsigned int n = rows.size();

	while((rows = selection->get_selected_rows()).size() > 0)
	{
		model->erase(model->get_iter(rows[0]));
	}

	model->rebuild_column_num();
	
	if(n == 1)
		doc.flash_message(_("%d subtitle has been deleted."), n);
	else
		doc.flash_message(_("%d subtitles have been deleted."), n);

	if(!previous)
		previous = model->getFirst();

	if(previous)
		doc.get_subtitle_view()->select_and_set_cursor(previous);

	return true;
}
