#include "MoveSubtitles.h"

/*
 *	Deplace les sous-titres select de "msecs"
 *	start et end pour savoir s'il faut modifiers les deux valeurs
 *	just_selection egale true permet de modifier seulement les elements select
 *	si false alors on modifiers tous les sous-titres aprés le premiers select 
 */
bool MoveSubtitles::execute(Document &doc, long int msecs, bool start, bool end, bool just_selection)
{
	if(just_selection)
	{
		Gtk::TreeNodeChildren rows = doc.get_subtitle_model()->children();

		if(rows.size() == 0)
			return false;

		if(start && !end) // seulement start
		{
			for(Gtk::TreeIter it = rows.begin(); it; ++it)
			{
				SubtitleModifier subtitle(it);
				subtitle.set_start( SubtitleTime( subtitle.get_start().totalmsecs + msecs ) );
			}
		}
		else if(!start && end) // seulement end
		{
			for(Gtk::TreeIter it = rows.begin(); it; ++it)
			{
				SubtitleModifier subtitle(it);
				subtitle.set_end( SubtitleTime( subtitle.get_end().totalmsecs + msecs ) );
			}
		}
		else if(start && end) // start et end
		{
			for(Gtk::TreeIter it = rows.begin(); it; ++it)
			{
				SubtitleModifier subtitle(it);
				subtitle.set_start_and_end( 
						SubtitleTime( subtitle.get_start().totalmsecs + msecs ),
						SubtitleTime( subtitle.get_end().totalmsecs + msecs ) );
			}
		}
	}
	else
	{
#warning "FIXME: just_selection==false"
		Gtk::TreeIter it = doc.get_subtitle_view()->getSelected();

		for(; it; ++it)
		{
			SubtitleModifier subtitle(it);
			subtitle.set_start_and_end( 
					SubtitleTime( subtitle.get_start().totalmsecs + msecs ),
					SubtitleTime( subtitle.get_end().totalmsecs + msecs ) );
		}
	}

	doc.emit_signal("subtitle-time-changed");

	return true;
}

