#include "Selection.h"

/*
 *
 */
bool Selection::execute(Document &doc, TYPE type)
{
	SubtitleModelPtr model = doc.get_subtitle_model();
	SubtitleViewPtr view = doc.get_subtitle_view();
	
	if(type == ALL)
	{
		view->get_selection()->select_all();
		return true;
	}
	else if(type == INVERT)
	{
		Glib::RefPtr<Gtk::TreeSelection> selection = view->get_selection();

		Gtk::TreeNodeChildren rows = doc.get_subtitle_model()->children();
		
		for(Gtk::TreeIter it = rows.begin(); it; ++it)
		{
			if(selection->is_selected(it))
				selection->unselect(it);
			else
				selection->select(it);
		}
		return true;
	}
	else if(type == PREVIOUS || type == NEXT)
	{
		Gtk::TreeIter select = view->getSelected();
		if(select)
		{
			Gtk::TreeIter it;
			if(type == PREVIOUS)
				it = model->find_previous(select);
			else
				it = model->find_next(select);

			if(it)
			{
				view->select_and_set_cursor(it);
				return true;
			}
		}
		else
		{
			Gtk::TreeIter it = model->getFirst();
			if(it)
			{
				view->select_and_set_cursor(it);
				return true;
			}
		}
	}
	return false;
}

