#ifndef _MPlayer_h
#define _MPlayer_h

#include "Player.h"

class MPlayer : public Player
{
public:
	MPlayer();
	~MPlayer();

	/*
	 *	open movie
	 */
	bool open(const Glib::ustring &uri);

	/*
	 *
	 */
	bool is_playing();

	/*
	 *
	 */
	void play();

	/*
	 *
	 */
	void pause();

	/*
	 *
	 */
	long get_duration();

	/*
	 *
	 */
	long get_position();

	/*
	 *
	 */
	void seek(long position);
	
	/*
	 *
	 */
	void seek(long start, long end);

	/*
	 *
	 */
	void show_text(const Glib::ustring& text);
protected:

	/*
	 *	xid = xwindow
	 */
	bool create(const Glib::ustring &uri);

	/*
	 *
	 */
	void close_pid();
	void close_iochannel();

	/*
	 *
	 */
	void command(const Glib::ustring &cmd);
	
	/*
	 *
	 */
	Glib::ustring get(const Glib::ustring &cmd);

	int			get_int(const Glib::ustring &cmd);
	float		get_float(const Glib::ustring &cmd);
	double	get_double(const Glib::ustring &cmd);

	/*
	 *
	 */
	bool on_output_monitor(Glib::IOCondition);

protected:
	Glib::Pid m_pid;
	Glib::RefPtr<Glib::IOChannel> m_input;
	Glib::RefPtr<Glib::IOChannel> m_output;

	Glib::ustring m_uri;
};

#endif//_MPlayer_h

